Unit ML01R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MLU01_p, MLU03_p, MLU09_p, MLU10_p, MLU04_p, MLU05_p, MLU06_p,
MLU07_p;

procedure ML01R(var A :Array of Real; M :Integer;
                var U :Array of Real; N :Integer;
                var X :Array of Real; var NB :Array of Integer;
                var P :Integer; EPS :Real; var XK :Array of Real);

implementation

procedure ML01R(var A :Array of Real; M :Integer;
                var U :Array of Real; N :Integer;
                var X :Array of Real; var NB :Array of Integer;
                var P :Integer; EPS :Real; var XK :Array of Real);
var
L,K,NI,NE,I,M1 :Integer;
TETA,MIN :Real;
const
O10T10 :Real = 10.0E6;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14;
begin

if ( P <> 1 ) 
 then goto _2;
for I:=1 to N do
 begin
  A[(M-2)+(I-1)*M] := -A[(M-2)+(I-1)*M];
_1:
 end;
_2:
MLU01(U,M);
M1 := M-2;
for I:=1 to M1 do
 begin
_3:
  NB[I-1] := Trunc( O10T10+I );
 end;
NI := 0;
NE := 1;
_4:
MLU03(MIN,U,M,A,N,NB,K);
goto _7;
_5:
MLU09(MIN,U,M,A,N,NB,K);
goto _7;
_6:
MLU10(MIN,U,M,A,N,NB,K,EPS);
_7:
if ( MIN < (-EPS) ) 
 then goto _10;
case NE of
 1: goto _8;
 2: goto _11;
 3: goto _11;
end;
_8:
NE := 2;
for I:=1 to M do
 begin
  if ( NB[I-1] > O10T10 ) 
   then NE := 3;
_9:
 end;
if ( NE = 3 ) and ( X[M-1] < (-EPS) ) 
 then goto _12;
case NE of
 1: goto _4;
 2: goto _5;
 3: goto _6;
end;
_10:
MLU04(U,M,A,N,K,XK);
MLU05(X,XK,M,L,TETA,EPS);
if ( TETA = O10T10 ) 
 then goto _13;
MLU06(X,XK,M,L,TETA);
MLU07(U,M,XK,L);
NB[L-1] := K;
NI := NI+1;
case NE of
 1: goto _4;
 2: goto _5;
 3: goto _6;
end;
_11:
if ( P <> 1 ) 
 then X[M-2] := -X[M-2];
P := 1;
goto _14;
_12:
P := 2;
goto _14;
_13:
P := 3;
_14:
end;

end.
